library queue;
use queue.queue_pkg.all;
use std.textio.all;

entity closed is
end closed;

architecture structural of closed is

  component join1
   generic (number_in     : integer;
	    name          : string;
	    file_name     : string;
	    debug_control : debug := none;
	    report_freq   : time := 10 fs);

   port (in_arc  : inout arc_array (1 to number_in) bus;
         out_arc : inout arc bus); 

  end component;

  component fork1
    generic (out_control   : distrib;
             number_out    : integer;
             name          : string;
             seed          : integer;
             generation    : frequency;
             file_name     : string;
             debug_control : debug := none;
             report_freq   : time := 10 fs);

    port (in_arc  : inout arc bus;
          out_arc : inout arc_array(1 to number_out) bus);
            
  end component;

  component server1
    generic (service_time  : time;
             name          : string;
	     service_dist  : distrib;
             server_type   : service_type := single_token;
	     service_capacity : integer      := 1;
             seed          : integer;
	     generation    : frequency;
             file_name     : string;
             debug_control : debug := none;
	     report_freq   : time := 10 fs);
             
    port (in_arc : inout arc bus; out_arc : inout arc bus);

  end component;

  component queue1
    generic (queue_length  : integer;
	     no_initial_tokens : integer;
             name          : string;
	     discipline	   : queue_discipline;
             file_name     : string;
             debug_control : debug := none;
             report_freq   : time := 10 fs);
             
    port (in_arc : inout arc bus; out_arc : inout arc bus);

  end component;

  for jo1: join1 use entity Work.join(behavior);
  for jo2: join1 use entity Work.join(behavior);
  for jo3: join1 use entity Work.join(behavior);
  for jo4: join1 use entity Work.join(behavior);
  for fo1: fork1 use entity Work.fork(behavior);
  for fo2: fork1 use entity Work.fork(behavior);
  for fo3: fork1 use entity Work.fork(behavior);
  for fo4: fork1 use entity Work.fork(behavior);
  for se1: server1 use entity Work.service(behavior);
  for se2: server1 use entity Work.service(behavior);
  for se3: server1 use entity Work.service(behavior);
  for se4: server1 use entity Work.service(behavior);
  for se5: server1 use entity Work.service(behavior);
  for se6: server1 use entity Work.service(behavior);
  for se7: server1 use entity Work.service(behavior);
  for se8: server1 use entity Work.service(behavior);    
  for se9: server1 use entity Work.service(behavior);    
  for se10: server1 use entity Work.service(behavior);
  for se11: server1 use entity Work.service(behavior);      
  for se12: server1 use entity Work.service(behavior);    
  for se13: server1 use entity Work.service(behavior);    
  for se14: server1 use entity Work.service(behavior);    
  for se15: server1 use entity Work.service(behavior);    
  for se16: server1 use entity Work.service(behavior);    
  for se17: server1 use entity Work.service(behavior);    
  for se18: server1 use entity Work.service(behavior);    
  for se19: server1 use entity Work.service(behavior);    
  for se20: server1 use entity Work.service(behavior);    
  for se21: server1 use entity Work.service(behavior);    
  for se22: server1 use entity Work.service(behavior);    
  for se23: server1 use entity Work.service(behavior);    
  for se24: server1 use entity Work.service(behavior);    
  for que1: queue1 use entity Work.queue(behavior);
  for que2: queue1 use entity Work.queue(behavior);
  for que3: queue1 use entity Work.queue(behavior);
  for que4: queue1 use entity Work.queue(behavior);
  for que5: queue1 use entity Work.queue(behavior);
  for que6: queue1 use entity Work.queue(behavior);
  for que7: queue1 use entity Work.queue(behavior);
  for que8: queue1 use entity Work.queue(behavior);
  for que9: queue1 use entity Work.queue(behavior);
  for que10: queue1 use entity Work.queue(behavior);
  for que11: queue1 use entity Work.queue(behavior);
  for que12: queue1 use entity Work.queue(behavior);
  for que13: queue1 use entity Work.queue(behavior);
  for que14: queue1 use entity Work.queue(behavior);
  for que15: queue1 use entity Work.queue(behavior);
  for que16: queue1 use entity Work.queue(behavior);
  for que17: queue1 use entity Work.queue(behavior);
  for que18: queue1 use entity Work.queue(behavior);

  signal arc1, arc2, arc3, arc4, arc5, arc6, arc7, arc8, arc9,
	 arc10, arc11, arc12, arc13, arc14, arc15, arc16, arc17,
	 arc18, arc19, arc20, arc21, arc22, arc23, arc24, arc25,
	 arc26, arc27, arc28, arc29, arc30, arc31, arc32, arc33,
         arc34, arc35, arc36, arc37, arc38, arc39, arc40, arc41,
	 arc42, arc43, arc44, arc45, arc46, arc47, arc48, arc49,
         arc50, arc51, arc52, arc53, arc54, arc55, arc56, arc57,
         arc58, arc59, arc60, arc61, arc62, arc63, arc64, arc65,
         arc66, arc67, arc68, arc69, arc70, arc71, arc72, arc73,
         arc74, arc75, arc76, arc77, arc78, arc79, arc80, arc81,
         arc82, arc83, arc84, arc85 : arc bus;

begin

  jo1:join1
    generic map (2, "J1", "results/join1.out", summary)
    port map(in_arc(1)=>arc1,in_arc(2)=>arc2,out_arc=>arc3);
  jo2:join1
    generic map (12, "J2", "results/join2.out", summary)
    port map(in_arc(1)=>arc8,in_arc(2)=>arc9,in_arc(3)=>arc27,
             in_arc(4)=>arc28,in_arc(5)=>arc41,in_arc(6)=>arc42,
             in_arc(7)=>arc43,in_arc(8)=>arc44,in_arc(9)=>arc55,
	     in_arc(10)=>arc56,in_arc(11)=>arc79,in_arc(12)=>arc80,
             out_arc=>arc10);
  jo3:join1
    generic map (6, "J3", "results/join3.out", summary)
    port map(in_arc(1)=>arc15,in_arc(2)=>arc16,in_arc(3)=>arc49,
             in_arc(4)=>arc50,in_arc(5)=>arc61,in_arc(6)=>arc62,
             out_arc=>arc17);
  jo4:join1
    generic map (6, "J4", "results/join4.out", summary)
    port map(in_arc(1)=>arc21,in_arc(2)=>arc22,in_arc(3)=>arc31,
	     in_arc(4)=>arc32,in_arc(5)=>arc83,in_arc(6)=>arc84,
             out_arc=>arc2);
  fo1:fork1
    generic map (fixed, 12, "F1", 0, (0.1, 0.1), "results/fork1.out")
    port map(arc3,out_arc(1)=>arc4,out_arc(2)=>arc5,out_arc(3)=>arc23,
	     out_arc(4)=>arc24, out_arc(5)=>arc33, out_arc(6)=>arc34,
             out_arc(7)=>arc35, out_arc(8)=>arc36,out_arc(9)=>arc51,
	     out_arc(10)=>arc52, out_arc(11)=>arc75, out_arc(12)=>arc76);
  fo2:fork1
    generic map (fixed, 6, "F2", 0, (0.1, 0.1), "results/fork2.out")
    port map(arc10,out_arc(1)=>arc11,out_arc(2)=>arc12,out_arc(3)=>arc45,
             out_arc(4)=>arc46,out_arc(5)=>arc57,out_arc(6)=>arc58);
  fo3:fork1
    generic map (fixed, 2, "F3", 0, (0.1, 0.1), "results/fork3.out")
    port map(arc17,out_arc(1)=>arc18,out_arc(2)=>arc1);
  fo4:fork1
    generic map (fixed, 6, "F4", 0, (0.1, 0.1), "results/fork4.out")
    port map(arc18,out_arc(1)=>arc19,out_arc(2)=>arc20,out_arc(3)=>arc29,
	     out_arc(4)=>arc30,out_arc(5)=>arc81,out_arc(6)=>arc82);
  se1:server1
    generic map (10 fs, "S1", fixed, multi_token, 2, 4, (10.0, 15.0),
                    "results/server1.out", summary)
    port map(arc6,arc8);
  se2:server1
    generic map (5 fs, "S2", fixed, multi_token, 2, 4, (10.0, 15.0), 
			"results/server2.out", summary)
    port map(arc7,arc9);
  se3:server1
    generic map (15 fs, "S3", fixed, multi_token, 2, 4, (10.0, 15.0), 
			"results/server3.out", summary)
    port map(arc13,arc15);
  se4:server1
    generic map (15 fs, "S4", fixed, single_token, 1, 10, (10.0, 15.0), 
			"results/server4.out", summary)
    port map(arc14,arc16);
  se5:server1
    generic map (15 fs, "S5", fixed, multi_token, 2, 4, (10.0, 15.0), 
			"results/server5.out", summary)
    port map(arc19,arc21);
  se6:server1
    generic map (15 fs, "S6", fixed, single_token, 1, 6, (1.0, 15.0), 
			"results/server6.out", summary)
    port map(arc20,arc22);
  se7:server1
    generic map (15 fs, "S7", unif, single_token, 1, 6, (1.0, 15.0), 
			"results/server7.out", summary)
    port map(arc25,arc27);
  se8:server1
    generic map (15 fs, "S8", norm, single_token, 1, 6, (1.0, 1.0), 
			"results/server8.out", summary)
    port map(arc26,arc28);
  se9:server1
    generic map (15 fs, "S9", unif, single_token, 1, 6, (10.0, 15.0), 
			"results/server9.out", summary)
    port map(arc29,arc31);
  se10:server1
    generic map (15 fs, "S10", unif, single_token, 1, 6, (1.0, 1.0), 
			"results/server10.out", summary)
    port map(arc30,arc32);
  se11:server1
    generic map (15 fs, "S11", poiss, single_token, 1, 6, (1.0, 1.0), 
			"results/server11.out", summary)
    port map(arc37,arc41);
  se12:server1
    generic map (15 fs, "S12", unif, single_token, 1, 6, (10.0, 12.0), 
			"results/server12.out", summary)
    port map(arc38,arc42);
  se13:server1
    generic map (15 fs, "S13", norm, single_token, 1, 6, (15.0, 18.0), 
			"results/server13.out", summary)
    port map(arc39,arc43);
  se14:server1
    generic map (15 fs, "S14", unif, single_token, 1, 6, (1.0, 1.0), 
			"results/server14.out", summary)
    port map(arc40,arc44);
  se15:server1
    generic map (15 fs, "S15", erl, single_token, 1, 6, (12.0, 16.0), 
			"results/server15.out", summary)
    port map(arc47,arc49);
  se16:server1
    generic map (15 fs, "S16", norm, single_token, 1, 6, (1.0, 1.0), 
			"results/server16.out", summary)
    port map(arc48,arc50);
  se17:server1
    generic map (15 fs, "S17", unif, single_token, 1, 6, (1.0, 1.0), 
			"results/server17.out", summary)
    port map(arc53,arc55);
  se18:server1
    generic map (15 fs, "S18", erl, single_token, 1, 6, (1.0, 1.0), 
			"results/server18.out", summary)
    port map(arc54,arc56);
  se19:server1
    generic map (15 fs, "S19", erl, single_token, 1, 6, (1.0, 1.0), 
			"results/server19.out", summary)
    port map(arc59,arc61);
  se20:server1
    generic map (15 fs, "S20", erl, single_token, 1, 6, (1.0, 1.0), 
			"results/server20.out", summary)
    port map(arc60,arc62);
  se21:server1
    generic map (15 fs, "S21", erl, single_token, 1, 6, (1.0, 1.0), 
			"results/server21.out", summary)
    port map(arc77,arc79);
  se22:server1
    generic map (15 fs, "S22", erl, single_token, 1, 5, (10.0, 17.0), 
			"results/server22.out", summary)
    port map(arc78,arc80);
  se23:server1
    generic map (15 fs, "S23", unif, multi_token, 4, 6, (1.0, 1.0), 
			"results/server23.out", summary)
    port map(arc81,arc83);
  se24:server1
    generic map (15 fs, "S24", poiss, single_token, 1, 6, (1.0, 1.0), 
			"results/server24.out", summary)
    port map(arc82,arc84);
  que1:queue1
    generic map (1000, 10, "Q1", FIFO, "results/queue1.out", summary)
    port map(arc4,arc6);
  que2:queue1
    generic map (1000, 0, "Q2", LIFO, "results/queue2.out", summary)
    port map(arc5,arc7);
  que3:queue1
    generic map (100, 3, "Q3", LIFO, "results/queue3.out", summary)
    port map(arc11,arc13);
  que4:queue1
    generic map (100, 3, "Q4", LIFO, "results/queue4.out", summary)
    port map(arc12,arc14);
  que5:queue1
    generic map (100, 3, "Q5", FIFO, "results/queue5.out", summary)
    port map(arc23,arc25);
  que6:queue1
    generic map (100, 3, "Q6", FIFO, "results/queue6.out", summary)
    port map(arc24,arc26);
  que7:queue1
    generic map (100, 3, "Q7", FIFO, "results/queue7.out", summary)
    port map(arc33,arc37);
  que8:queue1
    generic map (100, 3, "Q8", FIFO, "results/queue8.out", summary)
    port map(arc34,arc38);
  que9:queue1
    generic map (100, 3, "Q9", FIFO, "results/queueD96.out", summary)
    port map(arc35,arc39);
  que10:queue1
    generic map (100, 3, "Q10", FIFO, "results/queue10.out", summary)
    port map(arc36,arc40);
  que11:queue1
    generic map (100, 3, "Q11", FIFO, "results/queue11.out", summary)
    port map(arc45,arc47);
  que12:queue1
    generic map (100, 3, "Q12", FIFO, "results/queue12.out", summary)
    port map(arc46,arc48);
  que13:queue1
    generic map (100, 3, "Q13", LIFO, "results/queue13.out", summary)
    port map(arc51,arc53);
  que14:queue1
    generic map (100, 3, "Q14", FIFO, "results/queue14.out", summary)
    port map(arc52,arc54);
  que15:queue1
    generic map (100, 3, "Q15", FIFO, "results/queue15.out", summary)
    port map(arc57,arc59);
  que16:queue1
    generic map (100, 3, "Q16", FIFO, "results/queue16.out", summary)
    port map(arc58,arc60);
  que17:queue1
    generic map (100, 3, "Q17", FIFO, "results/queue17.out", summary)
    port map(arc75,arc77);
  que18:queue1
    generic map (100, 3, "Q18", LIFO, "results/queue18.out", summary)
    port map(arc76,arc78);
end structural;
